/*===========================================================================
		\tgEGAL[{[hNX

		Copyright & Programmed by Y.Taniuchi ( TAN-Y )
===========================================================================*/

#include <windows.h>
#include <stdio.h>
#include <gx.h>
#include "CGAPISoftKeybVga.h"

extern unsigned char g_pbFont8x8[];
extern KeyInfo g_pKeyInfo[];

static unsigned char g_pKeyMap[80 * 5];

/*---------------------------------------------------------------------------
		RXgN^
---------------------------------------------------------------------------*/

CGAPISoftKeybVga::CGAPISoftKeybVga( long lXPos, long lYPos, const GXDisplayProperties *pGxdp, WORD wPixel, WORD wPixelRightBar )
{
	memcpy( &m_gxdp, pGxdp, sizeof(GXDisplayProperties) );


	m_lKeybXPos  = lXPos;
	m_lKeybYPos  = lYPos;
	m_lViewIndex = lXPos * m_gxdp.cbxPitch + lYPos * m_gxdp.cbyPitch;
	m_lXIndex    = m_gxdp.cbyPitch * 16;
	m_wPixel     = wPixel;

	m_wPixelRightBar = wPixelRightBar;

	m_blLockedCaps      = false;
	m_blLockedKana      = false;
	m_blLockedShiftLock = false;
	m_blPressedShift    = false;

	memset( m_pblPressedKeys, false, sizeof(bool) * KEYSTATUS_BUFSIZE );
	memset( m_pblDrawKeys   , false, sizeof(bool) * KEYSTATUS_BUFSIZE );
}


/*---------------------------------------------------------------------------
		e[ȕ
		e[û̓O[oɒuĂ邯ǁÃ\bhs
		CX^X̐ݒɊÂďĂƂ....
---------------------------------------------------------------------------*/

void CGAPISoftKeybVga::InitKeyTbl( void )
{
KeyInfo *pKeyInfoTmp = g_pKeyInfo;
int i;
unsigned char ucKeyIndex;

	for( i = 0; i < 80 * 5; i++ )
	{
		g_pKeyMap[i] = 0xff;
	}

	ucKeyIndex = 0;
	while ( pKeyInfoTmp->m_lPosX >= 0 ) {
		int iLen = strlen( pKeyInfoTmp->szKeyTopNorm );
		int iMapIndex = pKeyInfoTmp->m_lPosX + pKeyInfoTmp->m_lPosY * 80;

		for ( i = 0; i < (iLen * 2); i++ ) {
			g_pKeyMap[i + iMapIndex] = ucKeyIndex;
		}

		pKeyInfoTmp->m_lViewIndex = m_lViewIndex
								  + pKeyInfoTmp->m_lPosY * m_gxdp.cbxPitch * 16
								  - pKeyInfoTmp->m_lPosX * m_gxdp.cbyPitch * 8;

		pKeyInfoTmp++;
		ucKeyIndex++;
	}

}


/*---------------------------------------------------------------------------
		L[グ
---------------------------------------------------------------------------*/

void CGAPISoftKeybVga::KeyUp( int iKeyCode )
{
	switch( iKeyCode )
	{
		case 0x08:
		case 0x3f:
		{
			//	CTRL,GRPH  Shift Lock ̂
			if( m_blLockedShiftLock == false )
			{
				m_pblPressedKeys[iKeyCode] = false;
				m_pblDrawKeys[iKeyCode] = true;
			}
		}
		break;
		case 0x09:
		case 0x0c:
		case 0x0e:
		{
			//	Shift Lock,CAPS,Ji̓L[グȂɂȂ
		}
		break;
		case 0x0d:
		case 0x44:
		{
			if( m_blLockedShiftLock )
			{
				//	VtgbNL̏ꍇCAPS݂ȋ
				m_blPressedShift = ( m_pblPressedKeys[0x0d] |
										m_pblPressedKeys[0x44] );
				for( int i = 0x0f; i < 0x3f; i++ )
				{
					m_pblDrawKeys[i] = true;
				}
			} else {
				m_pblPressedKeys[iKeyCode] = false;
				m_blPressedShift = false;
				m_pblDrawKeys[iKeyCode] = true;
			}
		}
		break;
		default:
		{
			m_pblPressedKeys[iKeyCode] = false;
			m_pblDrawKeys[iKeyCode] = true;
		}
		break;
	}

}


/*---------------------------------------------------------------------------
		L[
---------------------------------------------------------------------------*/

void CGAPISoftKeybVga::KeyDown( int iKeyCode )
{
	switch( iKeyCode )
	{
		case 0x08:
		case 0x3f:
		{
			//	CTRL,GRPH  Shift Lock L CAPS Ɠ悤ȋ
			if( m_blLockedShiftLock )
			{
				m_pblPressedKeys[iKeyCode] =
					(m_pblPressedKeys[iKeyCode] ? false : true);
			} else {
				m_pblPressedKeys[iKeyCode] = true;
			}
			m_pblDrawKeys[iKeyCode] = true;

		}
		break;
		case 0x09:
		case 0x0c:
		case 0x0e:
		{
			//	Shift Lock,CAPS,Ji͔]\
			m_pblPressedKeys[iKeyCode] =
					(m_pblPressedKeys[iKeyCode] ? false : true);
			m_pblDrawKeys[iKeyCode] = true;

			//	`攻pXe[^XύX
			switch( iKeyCode )
			{
				case 0x09:
				{
					m_blLockedShiftLock =
						( m_blLockedShiftLock ? false : true);
					if( m_blLockedShiftLock == false )
					{
						m_blPressedShift = false;
						m_pblPressedKeys[0x0d] = false;
						m_pblDrawKeys[0x0d] = true;
						m_pblPressedKeys[0x44] = false;
						m_pblDrawKeys[0x44] = true;
						m_pblPressedKeys[0x08] = false;
						m_pblDrawKeys[0x08] = true;
						m_pblPressedKeys[0x3f] = false;
						m_pblDrawKeys[0x3f] = true;
					}
				}
				break;
				case 0x0c:
				{
					m_blLockedCaps = ( m_blLockedCaps ? false : true);
				}
				break;
				case 0x0e:
				{
					m_blLockedKana = ( m_blLockedKana ? false : true);
				}
				break;
			}

			//	ʃL[n͍ĕ`Ώ
			for( int i = 0x0f; i < 0x3f; i++ )
			{
				m_pblDrawKeys[i] = true;
			}
		}
		break;
		case 0x0d:
		case 0x44:
		{
			if( m_blLockedShiftLock )
			{
				//	VtgbNL̏ꍇCAPS݂ȋ
				m_pblPressedKeys[iKeyCode] =
						(m_pblPressedKeys[iKeyCode] ? false : true);
				m_pblDrawKeys[iKeyCode] = true;
			} else {
				m_pblPressedKeys[iKeyCode] = true;
				m_blPressedShift = true;
			}
			m_pblDrawKeys[iKeyCode] = true;
		}
		break;
		default:
		{
			m_pblPressedKeys[iKeyCode] = true;
			m_pblDrawKeys[iKeyCode] = true;
		}
		break;
	}
}


/*---------------------------------------------------------------------------
		L[{[hS̍ĕ`
---------------------------------------------------------------------------*/

void CGAPISoftKeybVga::Redraw( LPBYTE pDst )
{
	memset( m_pblDrawKeys, true, sizeof(bool) * KEYSTATUS_BUFSIZE );
	Draw( pDst );
}


/*---------------------------------------------------------------------------
		L[{[h`
---------------------------------------------------------------------------*/

void CGAPISoftKeybVga::Draw( LPBYTE pDst )
{
KeyInfo *pKeyInfoTmp = g_pKeyInfo;
bool *pblDrawKey = m_pblDrawKeys;
int i = 0;
LPCSTR *pszKeyTopNorms = &(g_pKeyInfo->szKeyTopNorm);
LPCSTR *pszKeyTopExts = pszKeyTopNorms;

	//
	//	Ji^VtgbNԂmF
	//
	if( m_blLockedKana )
	{
		if( m_blLockedShiftLock && m_blPressedShift )
		{
			pszKeyTopExts = &g_pKeyInfo->szKeyTopKanaShift;
		} else {
			pszKeyTopExts = &g_pKeyInfo->szKeyTopKana;
		}
	} else {
		if( m_blLockedShiftLock && m_blPressedShift )
		{
			pszKeyTopExts = &g_pKeyInfo->szKeyTopNormShift;
		}
	}

	//
	//	`
	//
	while ( pKeyInfoTmp->m_lPosX >= 0 ) {
		if ( *pblDrawKey ) {
			//
			//	`tOĂ
			//

			//PutKeytop( pDst, i );
			LPCSTR szStr = *pszKeyTopExts;

			if ( szStr == NULL ) {
				szStr = *pszKeyTopNorms;
			}

			LPBYTE pDstTmp = pDst + pKeyInfoTmp->m_lViewIndex;
			while ( *(szStr + 1) != NULL ) {
				PutFont( pDstTmp, *szStr, m_pblPressedKeys[i], false );
				pDstTmp -= m_lXIndex;
				szStr++;
			}
			PutFont( pDstTmp, *szStr, m_pblPressedKeys[i], true );

		}
		*pblDrawKey = false;

		i++;
		pblDrawKey++;
		pKeyInfoTmp++;

		pszKeyTopNorms += sizeof(KeyInfo) / sizeof(LPCSTR *);
		pszKeyTopExts  += sizeof(KeyInfo) / sizeof(LPCSTR *);
	}

}


/*---------------------------------------------------------------------------
		WL[R[h擾
---------------------------------------------------------------------------*/

int CGAPISoftKeybVga::GetKeytopCode( WORD wXPos, WORD wYPos )
{
long lVXPos, lVYPos;		//	V  Virtual  V ....

	lVXPos = (m_lKeybYPos - wYPos) /  8;	//	/ 4
	lVYPos = (wXPos - m_lKeybXPos) / 16;	//	/ 8

	int iIndex = lVXPos + lVYPos * 80;
	if( iIndex < 0 || iIndex > ( 80 * 5 ) - 1 )
	{
		return 0xff;
	}

	return g_pKeyMap[iIndex];
}


/*---------------------------------------------------------------------------
		L[\i]Oj
---------------------------------------------------------------------------*/

void CGAPISoftKeybVga::PutKeytop( LPBYTE pDst, int iKeytopCode )
{
KeyInfo *pKeyInfoTmp = g_pKeyInfo + iKeytopCode;
LPCSTR szStr = pKeyInfoTmp->szKeyTopNorm;

	if( *szStr == NULL )
	{
		return;
	}
	pDst += pKeyInfoTmp->m_lViewIndex;
	while( *(szStr + 1) != NULL )
	{
		PutFont( pDst, *szStr, m_pblPressedKeys[iKeytopCode], false );
		pDst -= m_lXIndex;
		szStr++;
	}
	PutFont( pDst, *szStr, m_pblPressedKeys[iKeytopCode], true );

}


/*---------------------------------------------------------------------------
		tHg\i]Oj
---------------------------------------------------------------------------*/

void CGAPISoftKeybVga::PutFont( LPBYTE pDst, unsigned char ucCode,	bool blPressed, bool blDrawRightBar )
{
	const unsigned char *pbUseFont;
	LPBYTE pDstTmp;
	LPBYTE pDstSub;


	if ( ucCode >= 0x80 ) {
		ucCode -= 0x40;
	} else {
		ucCode -= 0x20;
	}

	pbUseFont = g_pbFont8x8 + (DWORD)(ucCode) * 8;

	if ( blDrawRightBar ) {
		WORD wRightBar = m_wPixelRightBar;

		if ( blPressed == false ) {
			wRightBar = ~wRightBar;
		}

		for ( long y = 0; y < 8; y++ ) {
			pDstTmp = pDst + (y * 2    ) * m_gxdp.cbxPitch;
			pDstSub = pDst + (y * 2 + 1) * m_gxdp.cbxPitch;
			BYTE bData = *pbUseFont;
			if ( blPressed == false ) {
				bData = ~bData;
			}
			for ( long x = 0; x < 7; x++ ) {
				if ( bData & 0x80 ) {
					*(WORD *)pDstTmp = m_wPixel;
				} else {
					*(WORD *)pDstTmp = 0;
				}
				*(WORD *)pDstSub = *(WORD *)pDstTmp;
				pDstTmp -= m_gxdp.cbyPitch;
				pDstSub -= m_gxdp.cbyPitch;
				if ( bData & 0x80 ) {
					*(WORD *)pDstTmp = m_wPixel;
				} else {
					*(WORD *)pDstTmp = 0;
				}
				*(WORD *)pDstSub = *(WORD *)pDstTmp;
				pDstTmp -= m_gxdp.cbyPitch;
				pDstSub -= m_gxdp.cbyPitch;
				bData <<= 1;
			}
			*(WORD *)pDstTmp = wRightBar;
			*(WORD *)pDstSub = wRightBar;
			pbUseFont++;
		}
	} else {
		for ( long y = 0; y < 8; y++ ) {
			pDstTmp = pDst + (y * 2    ) * m_gxdp.cbxPitch;
			pDstSub = pDst + (y * 2 + 1) * m_gxdp.cbxPitch;
			BYTE bData = *pbUseFont;
			if ( blPressed == false ) {
				bData = ~bData;
			}
			for ( long x = 0; x < 8; x++ ) {
				if ( bData & 0x80 ) {
					*(WORD *)pDstTmp = m_wPixel;
				} else {
					*(WORD *)pDstTmp = 0;
				}
				*(WORD *)pDstSub = *(WORD *)pDstTmp;
				pDstTmp -= m_gxdp.cbyPitch;
				pDstSub -= m_gxdp.cbyPitch;
				if ( bData & 0x80 ) {
					*(WORD *)pDstTmp = m_wPixel;
				} else {
					*(WORD *)pDstTmp = 0;
				}
				*(WORD *)pDstSub = *(WORD *)pDstTmp;
				pDstTmp -= m_gxdp.cbyPitch;
				pDstSub -= m_gxdp.cbyPitch;
				bData <<= 1;
			}
			pbUseFont++;
		}
	}
}


