/*===========================================================================
		M88 for WindowsMobile5.0 by NNK
		based on PocketPC Version by Y.Taniuchi ( TAN-Y )
		Original Version (c)cisc

		GAPIDrawVga NX
===========================================================================*/

#include "m88wm5.h"



// from NP2 - SCRNMNG.CPP

#define	GETRAWFRAMEBUFFER	0x00020001

enum {
	RFBIFMT_565		= 1,
	RFBIFMT_555		= 2,
	RFBIFMT_OTHER	= 3
};

static struct {
	WORD	wFormat;
	WORD	wBPP;
	VOID	*pFramePointer;
	int		cxStride;
	int		cyStride;
	int		cxPixels;
	int		cyPixels;
} rfbi;

static GXDisplayProperties GXGetDisplayPropertiesVGA(void) {

	HDC					hdc;
	GXDisplayProperties	ret;

	hdc = GetDC(NULL);
	ExtEscape(hdc, GETRAWFRAMEBUFFER, 0, NULL, sizeof(rfbi), (char *)&rfbi);
	ReleaseDC(NULL, hdc);
	ret.cxWidth  = rfbi.cxPixels;
	ret.cyHeight = rfbi.cyPixels;
	ret.cbxPitch = rfbi.cxStride;
	ret.cbyPitch = rfbi.cyStride;
	ret.cBPP     = rfbi.wBPP;
	ret.ffFormat = 0;
	switch(rfbi.wFormat) {
		case RFBIFMT_565:
			ret.ffFormat |= kfDirect565;
			break;

		case RFBIFMT_555:
			ret.ffFormat |= kfDirect555;
			break;
	}
	return(ret);
}

#define	GXBeginDrawVGA()		(rfbi.pFramePointer)
#define	GXEndDrawVGA()


/*--------------------------------------------------------------------------
		RXgN^
--------------------------------------------------------------------------*/

GAPIDrawVga::GAPIDrawVga() : WCEDraw()
{
}


/*--------------------------------------------------------------------------
		fXgN^
--------------------------------------------------------------------------*/

GAPIDrawVga::~GAPIDrawVga()
{
	if( GetHWnd() != NULL )
	{
		ActivateGAPI( false );
	}

	if( m_pKeyb != NULL )
	{
		delete m_pKeyb;
	}
}


/*--------------------------------------------------------------------------
		NXƂĂ̏iTuNXpj
--------------------------------------------------------------------------*/

bool GAPIDrawVga::Init00( void )
{
	m_blActiveGAPI = false;

	if ( ActivateGAPI(true) == false ) {
		return false;
	}

	m_lDstXXH = ( m_gxdp.cyHeight - 1 ) * m_gxdp.cbyPitch;

	if ( m_gxdp.ffFormat | kfDirect565 ) {
		m_pKeyb = new CGAPISoftKeybVga( 400, m_gxdp.cyHeight - 1, &m_gxdp, 0xffff, 0x8410 );
	} else {
		m_pKeyb = new CGAPISoftKeybVga( 400, m_gxdp.cyHeight - 1, &m_gxdp, 0xffff, 0x4210 );
	}

	m_pKeyb->InitKeyTbl();
	SetDrawKeybStatus( kbredraw );

	return true;
}

void GAPIDrawVga::SetConfig( PC8801::Config *pConfig )
{
	m_pConfig = pConfig;
}

/*--------------------------------------------------------------------------
		S̍ĕ`w
--------------------------------------------------------------------------*/

void GAPIDrawVga::RequestPaint()
{
	void *pDst = GXBeginDrawVGA();
	ZeroMemory( pDst, m_gxdp.cbyPitch * m_gxdp.cyHeight );
	GXEndDrawVGA();
	SetDrawKeybStatus( kbredraw );
	WCEDraw::RequestPaint();
}


/*--------------------------------------------------------------------------
		zVRAMobt@̊mہiM88RAɓnj
--------------------------------------------------------------------------*/

uint8 *GAPIDrawVga::AllocVirtualDrawArea( uint width, uint height, uint bpp )
{
	return (uint8 *)malloc( width * height * bpp / 8 );
}


/*--------------------------------------------------------------------------
		n
--------------------------------------------------------------------------*/

void GAPIDrawVga::CleanupSub( uint8 *pImageSrc )
{

	if( pImageSrc != NULL )
	{
		free( pImageSrc );
	}
}


/*--------------------------------------------------------------------------
		GAPI ̗L^
--------------------------------------------------------------------------*/

bool GAPIDrawVga::ActivateGAPI( bool blActive )
{
	CriticalSection::Lock lock(m_csdraw);

	if ( blActive ) {
		if ( ::GXOpenDisplay(GetHWnd(),GX_FULLSCREEN) == 0 ) {
			return false;
		}

		m_gxdp = ::GXGetDisplayPropertiesVGA();
		void *pDst = GXBeginDrawVGA();
		ZeroMemory( pDst, m_gxdp.cbyPitch * m_gxdp.cyHeight );
		GXEndDrawVGA();
	} else {
		::GXCloseDisplay();
	}
	m_blActiveGAPI = blActive;

	return true;
}


/*--------------------------------------------------------------------------
		ۂɕ`悷
--------------------------------------------------------------------------*/

void GAPIDrawVga::DrawToScreen( uint8 *pImageSrc, RECT *pRect )
{
	if ( m_blActiveGAPI == false ) {
		return;
	}
	void *pDst = GXBeginDrawVGA();

	if ( pDst != NULL ) {
		if ( m_pConfig->flags & PC8801::Config::fv15k ) {
			if ( m_pConfig->flags & PC8801::Config::fullline ) {
				if ( m_gxdp.ffFormat | kfDirect565 ) {
					DrawWindowH565( pDst, pImageSrc, pRect );	//16bit(555)win
				} else if ( m_gxdp.ffFormat | kfDirect555 ) {
					DrawWindowH555( pDst, pImageSrc, pRect );	//16bit(565)win
				}
			} else {
				if ( m_gxdp.ffFormat | kfDirect565 ) {
					DrawWindowH565_15kHz( pDst, pImageSrc, pRect );	//16bit(555)win
				} else if ( m_gxdp.ffFormat | kfDirect555 ) {
					DrawWindowH555_15kHz( pDst, pImageSrc, pRect );	//16bit(565)win
				}
			}
		} else {
			if ( m_gxdp.ffFormat | kfDirect565 ) {
				DrawWindowH565_400( pDst, pImageSrc, pRect );	//16bit(555)win
			} else if ( m_gxdp.ffFormat | kfDirect555 ) {
				DrawWindowH555_400( pDst, pImageSrc, pRect );	//16bit(565)win
			}
		}

		//
		//	L[{[hS̍ĕ`
		//
		switch ( m_dks ) {
		case kbdraw:
			m_pKeyb->Draw( (LPBYTE)pDst );
			break;
		case kbredraw:
			m_pKeyb->Redraw( (LPBYTE)pDst );
			break;
		}
		SetDrawKeybStatus( kbnormal );

		GXEndDrawVGA();
	}
}


/*--------------------------------------------------------------------------
		`惋[`
--------------------------------------------------------------------------*/

//
//	16bpp(555) / 
//
void GAPIDrawVga::DrawWindowH555( void *pDst, const uint8 *pSrc, RECT *pRect )
{
	uint8 *pDstOrg;
	uint8 *pDstTmp;
	uint8 *pDstSub;
	const uint8 *pSrcTmp;
	DWORD dwRed;
	DWORD dwGreen;
	DWORD dwBlue;


	pSrcTmp = pSrc + pRect->left + pRect->top * GetWidth() * 2;
	pDstOrg = ((uint8 *)(pDst) + m_lDstXXH );

	pRect->top    >>= 1;
	pRect->bottom >>= 1;

	for( LONG y = pRect->top; y <= pRect->bottom; y++ )
	{
		pDstTmp = pDstOrg + (y * 2    ) * m_gxdp.cbxPitch;
		pDstSub = pDstOrg + (y * 2 + 1) * m_gxdp.cbxPitch;
		pSrcTmp = pSrc + GetWidth() * y * 2;
		for ( LONG x = pRect->left; x <= pRect->right; x++ ) {

			dwRed   = GetPalette()[*pSrcTmp].red;
			dwGreen = GetPalette()[*pSrcTmp].green;
			dwBlue  = GetPalette()[*pSrcTmp].blue;
			pSrcTmp++;


			*(WORD *)pDstTmp = ((WORD)(dwRed   & 0xf8) << 7)
							 | ((WORD)(dwGreen & 0xf8) << 2
							 |  (WORD)(dwBlue        ) >> 3);
			*(WORD *)pDstSub = *(WORD *)pDstTmp;

			pDstTmp -= m_gxdp.cbyPitch;
			pDstSub -= m_gxdp.cbyPitch;
		}
	}
}


//
//	16bpp(565) / 
//
void GAPIDrawVga::DrawWindowH565( void *pDst, const uint8 *pSrc, RECT *pRect )
{
	uint8 *pDstOrg;
	uint8 *pDstTmp;
	uint8 *pDstSub;
	const uint8 *pSrcTmp;
	DWORD dwRed;
	DWORD dwGreen;
	DWORD dwBlue;


	pSrcTmp = pSrc + pRect->left + pRect->top * GetWidth() * 2;
	pDstOrg = ((uint8 *)(pDst) + m_lDstXXH );

	pRect->top    >>= 1;
	pRect->bottom >>= 1;

	for( LONG y = pRect->top; y <= pRect->bottom; y++ )
	{
		pDstTmp = pDstOrg + (y * 2    ) * m_gxdp.cbxPitch;
		pDstSub = pDstOrg + (y * 2 + 1) * m_gxdp.cbxPitch;
		pSrcTmp = pSrc + GetWidth() * y * 2;
		for ( LONG x = pRect->left; x <= pRect->right; x++ ) {

			dwRed   = GetPalette()[*pSrcTmp].red;
			dwGreen = GetPalette()[*pSrcTmp].green;
			dwBlue  = GetPalette()[*pSrcTmp].blue;
			pSrcTmp++;

			*(WORD *)pDstTmp = ((WORD)(dwRed   & 0xf8) << 8)
							 | ((WORD)(dwGreen & 0xfc) << 3
							 |  (WORD)(dwBlue        ) >> 3);
			*(WORD *)pDstSub = *(WORD *)pDstTmp;

			pDstTmp -= m_gxdp.cbyPitch;
			pDstSub -= m_gxdp.cbyPitch;
		}
	}
}


//
//	16bpp(555) /  (15kHz Scanline)
//
void GAPIDrawVga::DrawWindowH555_15kHz( void *pDst, const uint8 *pSrc, RECT *pRect )
{
	uint8 *pDstOrg;
	uint8 *pDstTmp;
	const uint8 *pSrcTmp;
	DWORD dwRed;
	DWORD dwGreen;
	DWORD dwBlue;


	pSrcTmp = pSrc + pRect->left + pRect->top * GetWidth() * 2;
	pDstOrg = ((uint8 *)(pDst) + m_lDstXXH );

	pRect->top    >>= 1;
	pRect->bottom >>= 1;

	for( LONG y = pRect->top; y <= pRect->bottom; y++ )
	{
		pDstTmp = pDstOrg + (y * 2) * m_gxdp.cbxPitch;
		pSrcTmp = pSrc + GetWidth() * y * 2;
		for ( LONG x = pRect->left; x <= pRect->right; x++ ) {

			dwRed   = GetPalette()[*pSrcTmp].red;
			dwGreen = GetPalette()[*pSrcTmp].green;
			dwBlue  = GetPalette()[*pSrcTmp].blue;
			pSrcTmp++;


			*(WORD *)pDstTmp = ((WORD)(dwRed   & 0xf8) << 7)
							 | ((WORD)(dwGreen & 0xf8) << 2
							 |  (WORD)(dwBlue        ) >> 3);

			pDstTmp -= m_gxdp.cbyPitch;
		}
	}
}


//
//	16bpp(565) / 
//
void GAPIDrawVga::DrawWindowH565_15kHz( void *pDst, const uint8 *pSrc, RECT *pRect )
{
	uint8 *pDstOrg;
	uint8 *pDstTmp;
	const uint8 *pSrcTmp;
	DWORD dwRed;
	DWORD dwGreen;
	DWORD dwBlue;


	pSrcTmp = pSrc + pRect->left + pRect->top * GetWidth() * 2;
	pDstOrg = ((uint8 *)(pDst) + m_lDstXXH );

	pRect->top    >>= 1;
	pRect->bottom >>= 1;

	for( LONG y = pRect->top; y <= pRect->bottom; y++ )
	{
		pDstTmp = pDstOrg + (y * 2    ) * m_gxdp.cbxPitch;
		pSrcTmp = pSrc + GetWidth() * y * 2;
		for ( LONG x = pRect->left; x <= pRect->right; x++ ) {

			dwRed = GetPalette()[*pSrcTmp].red;
			dwGreen = GetPalette()[*pSrcTmp].green;
			dwBlue = GetPalette()[*pSrcTmp].blue;
			pSrcTmp++;

			*(WORD *)pDstTmp = ((WORD)(dwRed   & 0xf8) << 8)
							 | ((WORD)(dwGreen & 0xfc) << 3
							 |  (WORD)(dwBlue        ) >> 3);

			pDstTmp -= m_gxdp.cbyPitch;
		}
	}
}






//
//	16bpp(555) /  (400line)
//
void GAPIDrawVga::DrawWindowH555_400( void *pDst, const uint8 *pSrc, RECT *pRect )
{
	uint8 *pDstOrg;
	uint8 *pDstTmp;
	const uint8 *pSrcTmp;
	DWORD dwRed;
	DWORD dwGreen;
	DWORD dwBlue;


	pSrcTmp = pSrc + pRect->left + pRect->top * GetWidth();
	pDstOrg = ((uint8 *)(pDst) + m_lDstXXH );

	for( LONG y = pRect->top; y <= pRect->bottom; y++ )
	{
		pDstTmp = pDstOrg + y * m_gxdp.cbxPitch;
		pSrcTmp = pSrc + GetWidth() * y;
		for ( LONG x = pRect->left; x <= pRect->right; x++ ) {

			dwRed   = GetPalette()[*pSrcTmp].red;
			dwGreen = GetPalette()[*pSrcTmp].green;
			dwBlue  = GetPalette()[*pSrcTmp].blue;
			pSrcTmp++;


			*(WORD *)pDstTmp = ((WORD)(dwRed   & 0xf8) << 7)
							 | ((WORD)(dwGreen & 0xf8) << 2
							 |  (WORD)(dwBlue        ) >> 3);

			pDstTmp -= m_gxdp.cbyPitch;
		}
	}
}


//
//	16bpp(565) / 
//
void GAPIDrawVga::DrawWindowH565_400( void *pDst, const uint8 *pSrc, RECT *pRect )
{
	uint8 *pDstOrg;
	uint8 *pDstTmp;
	const uint8 *pSrcTmp;
	DWORD dwRed;
	DWORD dwGreen;
	DWORD dwBlue;


	pSrcTmp = pSrc + pRect->left + pRect->top * GetWidth();
	pDstOrg = ((uint8 *)(pDst) + m_lDstXXH );

	for( LONG y = pRect->top; y <= pRect->bottom; y++ )
	{
		pDstTmp = pDstOrg + y * m_gxdp.cbxPitch;
		pSrcTmp = pSrc + GetWidth() * y;
		for ( LONG x = pRect->left; x <= pRect->right; x++ ) {

			dwRed   = GetPalette()[*pSrcTmp].red;
			dwGreen = GetPalette()[*pSrcTmp].green;
			dwBlue  = GetPalette()[*pSrcTmp].blue;
			pSrcTmp++;

			*(WORD *)pDstTmp = ((WORD)(dwRed   & 0xf8) << 8)
							 | ((WORD)(dwGreen & 0xfc) << 3
							 |  (WORD)(dwBlue        ) >> 3);

			pDstTmp -= m_gxdp.cbyPitch;
		}
	}
}
