/*===========================================================================
		M88 for WindowsMobile5.0 by NNK
		based on PocketPC Version by Y.Taniuchi ( TAN-Y )
		Original Version (c)cisc

		vpeBy[W֌WNX
===========================================================================*/

#include "m88wm5.h"

#define BSTATE(b) (b ? BST_CHECKED : BST_UNCHECKED)

LPCWSTR aszKeyNames[];

using namespace PC8801;



static bool OpenDiskImage( HWND hWndParent, HINSTANCE hInstance, LPTSTR szRetBuf, DWORD dwBufSize )
{
	OPENFILENAME ofn;

	::ZeroMemory( &ofn, sizeof(OPENFILENAME) );
	ofn.lStructSize     = sizeof(OPENFILENAME);
	ofn.hwndOwner       = hWndParent;
	ofn.hInstance       = hInstance;
	ofn.lpstrFilter     = _T("D88C[W{*.D88|*.88D|*.DAT}\0*.D88;*.88D;*.DAT\0\0");
	ofn.lpstrFile       = szRetBuf;
	ofn.nMaxFile        = dwBufSize;
	ofn.Flags           = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrDefExt     = NULL;

	if ( ::GetOpenFileName(&ofn) == FALSE ) {
		return false;
	}
	return true;
}


/*---------------------------------------------------------------------------
		RXgN^
---------------------------------------------------------------------------*/

Wm5ConfigDialog::Wm5ConfigDialog( PC8801::Config *pConfig, CDiskImageManager *pDiskImageManager, Wm5KeyDefFile *pKeyDef ) : CConfigDialog( CONFIGDIALOG_PAGEMAX, pConfig, pDiskImageManager )
{
	m_pKeyDef = pKeyDef;
}


/*---------------------------------------------------------------------------
		fXgN^
---------------------------------------------------------------------------*/

Wm5ConfigDialog::~Wm5ConfigDialog()
{
	RELEASE_OBJ( m_pPropAbout   );
	RELEASE_OBJ( m_pPropKeyMap  );
	RELEASE_OBJ( m_pPropDipSW2  );
	RELEASE_OBJ( m_pPropDipSW1  );
	RELEASE_OBJ( m_pPropSound3  );
	RELEASE_OBJ( m_pPropSound2  );
	RELEASE_OBJ( m_pPropSound1  );
	RELEASE_OBJ( m_pPropCPU     );
	RELEASE_OBJ( m_pPropDisk    );
	RELEASE_OBJ( m_pPropControl );
	RELEASE_OBJ( m_pPropDraw    );
}


/*---------------------------------------------------------------------------
		_CAOtO擾
---------------------------------------------------------------------------*/

DWORD Wm5ConfigDialog::GetDialogFlag()
{
	return PSH_NOAPPLYNOW | PSH_MAXIMIZE;
}


/*---------------------------------------------------------------------------
		PSP
---------------------------------------------------------------------------*/

bool Wm5ConfigDialog::InitPSP( HPROPSHEETPAGE *phPSP )
{
	m_pPropDisk = new CPropDisk( GetConfig(), GetDiskImageManager() );
	phPSP[0] = m_pPropDisk->Create();

	m_pPropDraw = new CPropDraw( GetConfig() );
	phPSP[1] = m_pPropDraw->Create();

	m_pPropControl = new CPropControl( GetConfig() );
	phPSP[2] = m_pPropControl->Create();

	m_pPropCPU = new CPropCPU( GetConfig() );
	phPSP[3] = m_pPropCPU->Create();

	m_pPropSound1 = new CPropSound1( GetConfig() );
	phPSP[4] = m_pPropSound1->Create();

	m_pPropSound2 = new CPropSound2( GetConfig() );
	phPSP[5] = m_pPropSound2->Create();

	m_pPropSound3 = new CPropSound3( GetConfig() );
	phPSP[6] = m_pPropSound3->Create();

	m_pPropDipSW1 = new CPropDipSW1( GetConfig() );
	phPSP[7] = m_pPropDipSW1->Create();

	m_pPropDipSW2 = new CPropDipSW2( GetConfig() );
	phPSP[8] = m_pPropDipSW2->Create();

	m_pPropKeyMap = new CPropKeyMap( GetConfig(), m_pKeyDef );
	phPSP[9] = m_pPropKeyMap->Create();

	m_pPropAbout = new CPropAbout( GetConfig() );
	phPSP[10] = m_pPropAbout->Create();

	return true;
}


/*---------------------------------------------------------------------------
		PROPSHEETHEADER ̏
---------------------------------------------------------------------------*/

void Wm5ConfigDialog::InitPSPHeader( PROPSHEETHEADER *pPSPHeader )
{
}




/*===========================================================================
		CPropControl
===========================================================================*/

void CPropControl::SetActive(HWND hdlg)
{
	int iDlgItem = 0;

	switch( GetConfig()->basicmode ) {
	case PC8801::Config::N80:
		iDlgItem = IDC_CONTROL_N;
		break;
	case PC8801::Config::N88V1:
		iDlgItem = IDC_CONTROL_N88V1S;
		break;
	case PC8801::Config::N88V1H:
		iDlgItem = IDC_CONTROL_N88V1H;
		break;
	case PC8801::Config::N88V2:
		iDlgItem = IDC_CONTROL_N88V2;
		break;
	}

	if ( iDlgItem ) {
		::SendDlgItemMessage( hdlg, iDlgItem, BM_SETCHECK, BST_CHECKED, 0 );
	}

	::SetWindowLong( hdlg, DWL_MSGRESULT, 0 );
}


bool CPropControl::Command(HWND hdlg, HWND hwctl, UINT nc, UINT id)
{
	switch( id ) {
	case IDC_CONTROL_N:
		GetConfig()->basicmode = PC8801::Config::N80;
		break;

	case IDC_CONTROL_N88V1S:
		GetConfig()->basicmode = PC8801::Config::N88V1;
		break;

	case IDC_CONTROL_N88V1H:
		GetConfig()->basicmode = PC8801::Config::N88V1H;
		break;

	case IDC_CONTROL_N88V2:
		GetConfig()->basicmode = PC8801::Config::N88V2;
		break;

	default:
		return false;
	}

	return true;
}


/*===========================================================================
		CPropDisk
===========================================================================*/

void CPropDisk::SetActive(HWND hdlg)
{
	SetDiskImageList( hdlg, 0 );
	SetDiskImageList( hdlg, 1 );

	::SetWindowLong( hdlg, DWL_MSGRESULT, 0 );
}


bool CPropDisk::Command(HWND hdlg, HWND hwctl, UINT nc, UINT id)
{
	switch ( id ) {
	case IDC_DISK_DRV1IMGSEL:
		if ( nc == CBN_SELCHANGE ) {
			int iSel = ::SendDlgItemMessage( hdlg
										   , IDC_DISK_DRV1IMGSEL
										   , CB_GETCURSEL, 0, 0
										   );

			m_pDiskImageManager->OpenDiskImage( 0, "", 0, iSel - 1, false );
		}
		break;

	case IDC_DISK_DRV2IMGSEL:
		if ( nc == CBN_SELCHANGE ) {
			int iSel = ::SendDlgItemMessage( hdlg
										   , IDC_DISK_DRV2IMGSEL
										   , CB_GETCURSEL, 0, 0
										   );

			m_pDiskImageManager->OpenDiskImage( 1, "", 0, iSel - 1, false );
		}
		break;

	case IDC_DISK_DRV1CHG:
		{
			WCHAR szBuf[MAX_PATH + 1];

			if ( OpenDiskImage(hdlg,_Module.GetResourceInstance(),szBuf,MAX_PATH) ) {
				LPSTR szName = WideToMulti( szBuf );

				m_pDiskImageManager->OpenDiskImage( 0, szName, 0, 0, false );
				delete[] szName;
				SetDiskImageList( hdlg, 0 );
			}
		}
		break;

	case IDC_DISK_DRV2CHG:
		{
			WCHAR szBuf[MAX_PATH + 1];

			if( OpenDiskImage(hdlg,_Module.GetResourceInstance(),szBuf,MAX_PATH) ) {
				LPSTR szName = WideToMulti( szBuf );

				m_pDiskImageManager->OpenDiskImage( 1, szName, 0, 0, false );
				delete[] szName;
				SetDiskImageList( hdlg, 1 );
			}
		}
		break;

	case IDC_DISK_CHGBOTH:
		{
			WCHAR szBuf[MAX_PATH + 1];

			if( OpenDiskImage(hdlg,_Module.GetResourceInstance(),szBuf,MAX_PATH) ) {
				LPSTR szName = WideToMulti( szBuf );

				m_pDiskImageManager->OpenDiskImage( szName );
				delete[] szName;
				SetDiskImageList( hdlg, 0 );
				SetDiskImageList( hdlg, 1 );
			}
		}
		break;
	}

	return false;
}


void CPropDisk::SetDiskImageList( HWND hWnd, uint uiDrive )
{
	DiskManager *pDiskMgr = m_pDiskImageManager->GetDiskManager();
	int iDlgItem;
	int iDisks = Min(pDiskMgr->GetNumDisks(uiDrive), 60);

	if ( uiDrive == 0 ) {
		iDlgItem = IDC_DISK_DRV1IMGSEL;
	} else {
		iDlgItem = IDC_DISK_DRV2IMGSEL;
	}

	::SendDlgItemMessage( hWnd, iDlgItem, CB_RESETCONTENT, 0, 0 );


	::SendDlgItemMessage( hWnd, iDlgItem, CB_ADDSTRING, 0, (LPARAM)_T("No disk"));


	for ( int i = 0; i < iDisks; i++ ) {
		const char *szTitle = pDiskMgr->GetImageTitle( uiDrive, i );

		if ( szTitle == NULL ) {
			break;
		}

		if ( szTitle[0] == 0 ) {
			::SendDlgItemMessage( hWnd, iDlgItem, CB_ADDSTRING, 0, (LPARAM)_T("(untitled)"));
			continue;
		}

		LPWSTR wszTitle = MultiToWide( szTitle );
		::SendDlgItemMessage( hWnd, iDlgItem, CB_ADDSTRING, 0, (LPARAM)wszTitle );
		delete[] wszTitle;
	}

	::SendDlgItemMessage( hWnd, iDlgItem, CB_SETCURSEL, pDiskMgr->GetCurrentDisk( uiDrive ) + 1, 0 );


	if ( uiDrive == 0 ) {
		iDlgItem = IDC_DISK_DRV1IMGFILE;
	} else {
		iDlgItem = IDC_DISK_DRV2IMGFILE;
	}

	LPWSTR wszFileName = MultiToWide( m_pDiskImageManager->GetDiskImageName( uiDrive ) );

	::SendDlgItemMessage( hWnd, iDlgItem, WM_SETTEXT, 0, (LPARAM)wszFileName );
	delete[] wszFileName;

}

/*===========================================================================
		CPropKeyMap / CPropKeyMapKeySel
===========================================================================*/

void CPropKeyMap::InitDialog(HWND hdlg)
{
	HWND hWndList = GetDlgItem( IDC_LIST1 );
	LV_COLUMN col;

	ListView_SetExtendedListViewStyle( hWndList, LVS_EX_FULLROWSELECT );

	col.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	col.fmt = LVCFMT_LEFT;

	col.cx = 32;
	col.pszText = _T("");
	col.iSubItem = 0;
	ListView_InsertColumn( hWndList, 0, &col );

	col.cx = 64;
	col.pszText = _T("L[");
	col.iSubItem = 1;
	ListView_InsertColumn( hWndList, 1, &col );

	col.cx = 108;
	col.pszText = _T("PC88ł̃L[");
	col.iSubItem = 2;
	ListView_InsertColumn( hWndList, 2, &col );

	LPCWSTR *pszKeyName = aszKeyNames;
	hWndList = GetDlgItem( IDC_LIST2 );

	while ( *pszKeyName != 0 ) {
		::SendMessage( hWndList, LB_ADDSTRING, 0, (LPARAM)*pszKeyName );
		pszKeyName++;
	}

	m_pKeySelSubClass->SubclassWindow( GetDlgItem( IDC_LIST2 ) );
}


void CPropKeyMap::SetActive(HWND hdlg)
{
	ListView_DeleteAllItems( GetDlgItem( IDC_LIST1 ) );
	UpdateConfigKeyList();
}


bool CPropKeyMap::Command(HWND hdlg, HWND hwctl, UINT nc, UINT id)
{

	if ( id == IDC_DELETE ) {
		HWND hWndList = GetDlgItem( IDC_LIST1 );
		int iSelected = ListView_GetNextItem( hWndList, -1, LVNI_ALL | LVNI_SELECTED );
		if ( iSelected >= 0 ) {
			TCHAR szTmp[16];
			int iVKey;

			ListView_GetItemText( hWndList, iSelected, 0, szTmp, 15 );
			iVKey = _ttoi( szTmp );

			ListView_DeleteItem( hWndList, iSelected );
			m_pKeyDef->SetKeyCode( iVKey, -1 );
		}

	}

	return false;
}


void CPropKeyMap::UpdateConfigKeyList( void )
{
	HWND hWndList = GetDlgItem( IDC_LIST1 );
	int iLastLine = ListView_GetItemCount( hWndList );
	int aiVKList[256];
	int i, n;

	for ( i = 0; i < iLastLine; i++ ) {
		TCHAR szTmp[16];
		int iVKey;

		ListView_GetItemText( hWndList, i, 0, szTmp, 15 );
		iVKey = _ttoi( szTmp );

		aiVKList[i] = iVKey;
	}

	for ( i = 0; i < 256; i++ ) {
		if ( m_pKeyDef->GetKeyCode( i ) > -1 ) {
			WCHAR szTmp[24];
			LV_ITEM item;

			item.mask = LVIF_TEXT;

			for ( n = 0; n < iLastLine; n++ ) {
				if ( i == aiVKList[n] ) {
					//
					//	łɂ甲
					//
					item.iItem = n;
					break;
				}
			}

			if ( n == iLastLine ) {
				//
				//	ȂVsǉB
				//
				aiVKList[iLastLine] = i;
				::wsprintf( szTmp, _T("%d"), i );
				item.iItem = iLastLine;
				item.iSubItem = 0;
				item.pszText = (LPTSTR)szTmp;
				ListView_InsertItem( hWndList, &item );

				iLastLine++;
			}

			item.iSubItem = 1;
			if ( i == m_pKeyDef->GetGXKeyList()->vkUp ) {
				item.pszText = _T("");
			} else if ( i == m_pKeyDef->GetGXKeyList()->vkDown ) {
				item.pszText = _T("");
			} else if ( i == m_pKeyDef->GetGXKeyList()->vkLeft ) {
				item.pszText = _T("");
			} else if ( i == m_pKeyDef->GetGXKeyList()->vkRight ) {
				item.pszText = _T("");
			} else if ( i == m_pKeyDef->GetGXKeyList()->vkStart ) {
				item.pszText = _T("Start");
			} else if ( i == m_pKeyDef->GetGXKeyList()->vkA ) {
				item.pszText = _T("A");
			} else if ( i == m_pKeyDef->GetGXKeyList()->vkB ) {
				item.pszText = _T("B");
			} else if ( i == m_pKeyDef->GetGXKeyList()->vkC ) {
				item.pszText = _T("C");
			} else {
				item.pszText = _T("-");
			}
			ListView_SetItem( hWndList, &item );


			item.iSubItem = 2;
			item.pszText = (LPTSTR)aszKeyNames[m_pKeyDef->GetKeyCode( i )];
			ListView_SetItem( hWndList, &item );
		}
	}
}


LRESULT CPropKeyMapKeySel::OnKeyUp( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &blHandled )
{
	//
	//	ŃL[ݒXV
	//
	int iPC88KeyCode = SendMessage( LB_GETCURSEL, 0, 0 );
	if ( iPC88KeyCode == 0 || iPC88KeyCode == 9 || iPC88KeyCode == LB_ERR ) {
		//
		//	Is\̍ڂI
		//
		return 0;
	}
	m_pPropKeyMap->m_pKeyDef->SetKeyCode( (int)wParam, iPC88KeyCode );
	m_pPropKeyMap->UpdateConfigKeyList();

	return 0;
}


LRESULT CPropKeyMapKeySel::OnKeyDown( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &blHandled )
{
	return 0;
}


static LPCWSTR aszKeyNames[] = {
	L"----",
	L"F1", 	L"F2", L"F3", L"F4", L"F5",
	L"STOP", L"COPY", L"CTRL", L"----",
	L"ESC", L"TAB", L"CAPS", L"SHIFT", L"Ji",
	L"1", L"2", L"3", L"4", L"5", L"6", L"7", L"8", L"9", L"0",
	L"-", L"^", L"\\",
	L"Q", L"W", L"E", L"R", L"T", L"Y", L"U", L"I", L"O", L"P",
	L"@", L"[",
	L"A", L"S", L"D", L"F", L"G", L"H", L"J", L"K", L"L",
	L";", L":", L"]",
	L"Z", L"X", L"C", L"V", L"B", L"N", L"M",
	L",", L".", L"/", L"_",
	L"GRAPH", L"SPACE",
	L"BS", L"RETURN", L"RETURN", L"ESHIFT",
	L"ROLL UP", L"ROLL DOWN", L"INS", L"DEL",
	L"", L"", L"", L"",
	L"HOME/CLR", L"HELP", L"eL[ -", L"eL[ /",
	L"eL[ 7", L"eL[ 8", L"eL[ 9", L"eL[ *",
	L"eL[ 4", L"eL[ 5", L"eL[ 6", L"eL[ +",
	L"eL[ 1", L"eL[ 2", L"eL[ 3", L"eL[ =",
	L"eL[ 0", L"eL[ ,", L"eL[ .", L"eL[ RETURN",
	L"\0"
};


/*===========================================================================
		CPropDraw
===========================================================================*/

void CPropDraw::SetActive(HWND hdlg)
{
	int iDlgItem = 0;

	if ( GetConfig()->flags & PC8801::Config::fv15k ) {
		if ( GetConfig()->flags & PC8801::Config::fullline ) {
			iDlgItem = IDC_DRAWTYPE_NORMAL;
		} else {
			iDlgItem = IDC_DRAWTYPE_SCANLN;
		}
	} else {
		iDlgItem = IDC_DRAWTYPE_24kHz;
	}

	if ( iDlgItem ) {
		::SendDlgItemMessage( hdlg, iDlgItem, BM_SETCHECK, BST_CHECKED, 0 );
	}

	::SetWindowLong( hdlg, DWL_MSGRESULT, 0 );
}


bool CPropDraw::Command(HWND hdlg, HWND hwctl, UINT nc, UINT id)
{
	switch ( id ) {
	case IDC_DRAWTYPE_NORMAL:
		GetConfig()->flags |= PC8801::Config::fv15k;
		GetConfig()->flags |= PC8801::Config::fullline;
		break;

	case IDC_DRAWTYPE_SCANLN:
		GetConfig()->flags |=  PC8801::Config::fv15k;
		GetConfig()->flags &= ~PC8801::Config::fullline;
		break;

	case IDC_DRAWTYPE_24kHz:
		GetConfig()->flags &= ~PC8801::Config::fv15k;
		GetConfig()->flags |=  PC8801::Config::fullline;
		break;
	}

	return false;
}


/*===========================================================================
		CPropAbout
===========================================================================*/

void CPropAbout::InitDialog(HWND hdlg)
{
	::SendDlgItemMessage( hdlg, IDC_ABOUT_TEXT, WM_SETTEXT, 0,
					(LPARAM)
						_T("M88/wm5 rel ")_T(M88WM5_REL)_T("\n")
						_T("based on M88/ce rel 0.04\n\n")
						_T("Copyright (C) 1998, 1999 cisc\n")
						_T("Copyright (C) 2001, 2002 TAN-Y\n")
						_T("VGA Modified by NNK 2006")
					);
	::SendDlgItemMessage( hdlg, IDC_ABOUT_BOX, WM_SETTEXT, 0,
					(LPARAM)
						_T("IWi̍҂łcisc")
						_T("TAN-Y֑労ӁB\r\n")
						_T("zEv]EoO񍐂Ȃǂ\r\n")
						_T("nonaka@tt.rim.or.jp\r\n")
						_T("ւǂB\r\n")
						_T("Ə̂́AZĎԎȂƎvB")
					);
}


