/*===========================================================================
		M88 for WindowsMobile5.0 by NNK
		based on PocketPC Version by Y.Taniuchi ( TAN-Y )
		Original Version (c)cisc

		L[`t@CNX
===========================================================================*/

#include "m88wm5.h"

/*---------------------------------------------------------------------------
		RXgN^
---------------------------------------------------------------------------*/

Wm5KeyDefFile::Wm5KeyDefFile( const char *szFileName, GXKeyList *pGXkl )
{
	m_szFileName = NULL;
	SetFileName( szFileName );

	m_pGXkl = pGXkl;
	InitKey();
}


/*---------------------------------------------------------------------------
		fXgN^
---------------------------------------------------------------------------*/

Wm5KeyDefFile::~Wm5KeyDefFile()
{
	if( m_szFileName != NULL )
	{
		free( m_szFileName );
		m_szFileName = NULL;
	}
}


/*---------------------------------------------------------------------------
		t@Cݒ
---------------------------------------------------------------------------*/

void Wm5KeyDefFile::SetFileName( const char *szFileName )
{
	if( m_szFileName != NULL )
	{
		free( m_szFileName );
		m_szFileName = NULL;
	}

	m_szFileName = (char *)malloc( strlen( szFileName ) + 1 );
	if( m_szFileName != NULL )
	{
		strcpy( m_szFileName, szFileName );
	}
}


/*---------------------------------------------------------------------------
		L[`̏
---------------------------------------------------------------------------*/

void Wm5KeyDefFile::InitKey( void )
{
	for( int i = 0; i < 256; i++ )
	{
		m_aiKeyCode[i] = -1;
	}

	if( m_pGXkl == NULL )
	{
		return;
	}

	//
	//	ftHg̃L[zuZbgB
	//
	m_aiKeyCode[m_pGXkl->vkUp] = 0x57;			//	tenkey 6
	m_aiKeyCode[m_pGXkl->vkDown] = 0x55;		//	tenkey 4
	m_aiKeyCode[m_pGXkl->vkLeft] = 0x52;		//	tenkey 8
	m_aiKeyCode[m_pGXkl->vkRight] = 0x5a;		//	tenkey 2
	m_aiKeyCode[m_pGXkl->vkStart] = 0x42;		//	ret
	m_aiKeyCode[m_pGXkl->vkA] = 0x40;			//	space
	m_aiKeyCode[m_pGXkl->vkB] = 0x42;			//	ret
	m_aiKeyCode[m_pGXkl->vkC] = 0x40;			//	space

	m_aiKeyCode[VK_F23] = 0x40;					//	space
	m_aiKeyCode[0xc1] = 0x42;					//	ret
}


/*---------------------------------------------------------------------------
		[h
---------------------------------------------------------------------------*/

bool Wm5KeyDefFile::Load()
{
FileIO file;

	//
	//	t@Cǂݍ
	//

	if( file.Open( m_szFileName, FileIO::readonly ) )
	{
	const char *szLine = NULL;

		while( ( szLine = ReadLine( &file ) ) != NULL )
		{
			char *szVal = strchr( szLine, '=' );
			if( szVal != NULL )
			{
				*szVal = 0;
				szVal++;
				int iVal = atoi( szVal );
				if( iVal < KEYCODE_MIN || iVal > KEYCODE_MAX )
				{
					iVal = -1;
				}
				m_aiKeyCode[atoi( szLine )] = iVal;
			}
		}

		return true;
	}

	return false;
}


/*---------------------------------------------------------------------------
		Z[u
---------------------------------------------------------------------------*/

bool Wm5KeyDefFile::Save()
{
FileIO file;

	if( file.Open( m_szFileName, FileIO::create ) == false )
	{
		return false;
	}

	for( int i = 0; i < 256; i++ )
	{
	char szNumTemp[64];

		if( m_aiKeyCode[i] != -1 )
		{
			sprintf( szNumTemp, "%d=%d\r\n", i, m_aiKeyCode[i] );
			int iLen = strlen( szNumTemp );
			if( file.Write( szNumTemp, iLen ) < iLen )
			{
				return false;
			}
		}
	}


	file.Close();

	return true;
}

