/*===========================================================================
		M88 for WindowsMobile5.0 by NNK
		based on PocketPC Version by Y.Taniuchi ( TAN-Y )
		Original Version (c)cisc

		Wm5UI NX
===========================================================================*/

#include "m88wm5.h"

/*---------------------------------------------------------------------------
		RXgN^
---------------------------------------------------------------------------*/

Wm5UI::Wm5UI( HINSTANCE hInst )	: WCEUI( hInst )
{
	m_draw.SetConfig( GetM88Config() );
	m_pDraw   = &m_draw;
	m_pKeyIF  = &m_keyif;
	m_pKeyDef = NULL;
}


/*---------------------------------------------------------------------------
		fXgN^
---------------------------------------------------------------------------*/

Wm5UI::~Wm5UI()
{
}


/*---------------------------------------------------------------------------
		M88 ̏(TuNXp)
---------------------------------------------------------------------------*/

bool Wm5UI::InitM88Sub()
{
	::GXOpenInput();
	m_gxkl = ::GXGetDefaultKeys( GX_NORMALKEYS );

	m_pKeyDef = new Wm5KeyDefFile( M88WM5_KEYDEFFILENAME, &m_gxkl );
	m_pKeyDef->InitKey();
	m_pKeyDef->Load();

	return true;
}


/*---------------------------------------------------------------------------
		M88 ̌n(TuNXp)
---------------------------------------------------------------------------*/

void Wm5UI::CleanupM88Sub()
{
	if( m_pKeyDef != NULL )
	{
		m_pKeyDef->Save();
		delete m_pKeyDef;
		m_pKeyDef = NULL;
	}
	::GXCloseInput();
}


/*---------------------------------------------------------------------------
		EChE
---------------------------------------------------------------------------*/

HWND Wm5UI::CreateMainWindow( void )
{
	DWORD wstyle = WS_VISIBLE | WS_POPUP;

	HWND hWnd = CreateWindow( GetWindowClassName()
							, GetWindowTitle()
							, wstyle
							, 0		// x
							, 0		// y
							, 480	// w
							, 640	// h
							, NULL
							, NULL
							, GetInstance()
							, NULL
							);

	::SHFullScreen( hWnd, SHFS_HIDESIPBUTTON | SHFS_HIDETASKBAR );

	return hWnd;
}


/*---------------------------------------------------------------------------
		EChE֐
---------------------------------------------------------------------------*/

LRESULT Wm5UI::WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	static int  iDownKeyCode = 0xff;
	static bool IsLostFocus  = false;
	static bool IsExecFocus  = true;


	switch ( uMsg ) {
	case WM_ACTIVATE:
		switch ( LOWORD(wParam) ) {
		case WA_ACTIVE:
		case WA_CLICKACTIVE:
			if ( IsLostFocus != false ) {
				IsLostFocus = false;
				::GXResume();
				::SHFullScreen( GetHWnd(), SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON );
				m_draw.RequestPaint();
				Activate( true );
				m_draw.ActivateGAPI( true );
			}
			break;
		case WA_INACTIVE:
			if ( IsExecFocus == true ) {
				IsLostFocus = true;
				::GXSuspend();
				m_draw.ActivateGAPI( false );
				Activate( false );
				::SHFullScreen( GetHWnd(), SHFS_SHOWTASKBAR | SHFS_SHOWSIPBUTTON );
			}
			break;
		}
		break;

#if 0
	case WM_KILLFOCUS:
		if ( IsExecFocus == true ) {
			IsLostFocus = true;
			::GXSuspend();
			m_draw.ActivateGAPI( false );
			Activate( false );
			::SHFullScreen( GetHWnd(), SHFS_SHOWTASKBAR | SHFS_SHOWSIPBUTTON );
		}
		break;

	case WM_SETFOCUS:
		if ( IsLostFocus != false ) {
			IsLostFocus = false;
			::GXResume();
			::SHFullScreen( GetHWnd(), SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON );
			m_draw.RequestPaint();
			Activate( true );
			m_draw.ActivateGAPI( true );
		}
		break;
#endif

	case WM_SIZE:
		if ( LOWORD(lParam) == 640 ) {
			m_bLandscape = true;
		} else {
			m_bLandscape = false;
		}
		break;

	case WM_KEYDOWN:
		{
			short vkKey = (short)wParam;

			if ( lParam & ( 1 << 30 ) ) {
				//	O牟Ă珈Ȃ
				return 0;
			}

			if ( m_pKeyDef->GetKeyCode( vkKey ) >= 0 ) {
				m_keyif.KeyDown( m_pKeyDef->GetKeyCode( vkKey ) );
				return 0;
			}
#if 0
			if ( vkKey == m_gxkl.vkUp ) {
				m_keyif.KeyDown( 0x57 );	//	tenkey 6
				return 0;
			}
			if ( vkKey == m_gxkl.vkDown ) {
				m_keyif.KeyDown( 0x55 );	//	tenkey 4
				return 0;
			}
			if ( vkKey == m_gxkl.vkLeft ) {
				m_keyif.KeyDown( 0x52 );	//	tenkey 8
				return 0;
			}
			if ( vkKey == m_gxkl.vkRight ) {
				m_keyif.KeyDown( 0x5a );	//	tenkey 2
				return 0;
			}
			if ( vkKey == m_gxkl.vkStart ) {
				m_keyif.KeyDown( 0x42 );	//	ret
				return 0;
			}
			if ( vkKey == 0xc1 ) {
				m_keyif.KeyDown( 0x42 );	//	ret
				return 0;
			}
			if ( vkKey == VK_F23 ) {
				m_keyif.KeyDown( 0x40 );	//	space
				return 0;
			}
			if ( vkKey == m_gxkl.vkA ) {
				m_keyif.KeyDown( 0x40 );	//	space
				return 0;
			}
			if ( vkKey == m_gxkl.vkB ) {
				m_keyif.KeyDown( 0x42 );	//	ret
				return 0;
			}
			if ( vkKey == m_gxkl.vkC ) {
				m_keyif.KeyDown( 0x40 );	//	space
				return 0;
			}
#endif
		}
		break;

	case WM_KEYUP:
		{
			short vkKey = (short)wParam;

			if( m_pKeyDef->GetKeyCode(vkKey) >= 0 ) {
				m_keyif.KeyUp( m_pKeyDef->GetKeyCode( vkKey ) );
				return 0;
			}
#if 0
			if ( vkKey == m_gxkl.vkUp ) {
				m_keyif.KeyUp( 0x57 );	//	tenkey 6
				return 0;
			}
			if ( vkKey == m_gxkl.vkDown ) {
				m_keyif.KeyUp( 0x55 );	//	tenkey 4
				return 0;
			}
			if ( vkKey == m_gxkl.vkLeft ) {
				m_keyif.KeyUp( 0x52 );	//	tenkey 8
				return 0;
			}
			if ( vkKey == m_gxkl.vkRight ) {
				m_keyif.KeyUp( 0x5a );	//	tenkey 2
				return 0;
			}
			if ( vkKey == m_gxkl.vkStart ) {
				m_keyif.KeyUp( 0x42 );	//	ret
				return 0;
			}
			if ( vkKey == 0xc1 ) {
				m_keyif.KeyUp( 0x42 );	//	ret
				return 0;
			}
			if ( vkKey == VK_F23 ) {
				m_keyif.KeyUp( 0x40 );	//	space
				return 0;
			}
			if ( vkKey == m_gxkl.vkA ) {
				m_keyif.KeyUp( 0x40 );	//	space
				return 0;
			}
			if ( vkKey == m_gxkl.vkB ) {
				m_keyif.KeyUp( 0x42 );	//	ret
				return 0;
			}
			if ( vkKey == m_gxkl.vkC ) {
				m_keyif.KeyUp( 0x40 );	//	space
				return 0;
			}
#endif
		}
		break;

	case WM_LBUTTONDOWN:
		{
			int iKeyCode;

			if ( IsLandscape() == false ) {
				iKeyCode = m_draw.GetKeyb()->GetKeytopCode( LOWORD(lParam), HIWORD(lParam) );
			} else {
				iKeyCode = m_draw.GetKeyb()->GetKeytopCode( HIWORD(lParam), 640 - LOWORD(lParam) );
			}

			iDownKeyCode = iKeyCode;
			if ( iKeyCode < 0xff ) {
				m_draw.GetKeyb()->KeyDown( iKeyCode );
				if ( m_draw.GetKeyb()->GetPressedStatus(iKeyCode) ) {
					m_keyif.KeyDown( iKeyCode );
				} else {
					if ( iKeyCode == 0x09 ) {
						//
						//	ShiftLock̏ꍇSHIFT/CTRL/GRPH͉
						//
						m_keyif.KeyUp( 0x0d );
						m_keyif.KeyUp( 0x44 );
						m_keyif.KeyUp( 0x08 );
						m_keyif.KeyUp( 0x3f );
					}
				}
				m_draw.SetDrawKeybStatus( GAPIDrawVga::kbdraw );
			}
		}
		break;

	case WM_LBUTTONUP:
		{
			int iKeyCode;
			
			if ( IsLandscape() == false ) {
				iKeyCode = m_draw.GetKeyb()->GetKeytopCode( LOWORD(lParam), HIWORD(lParam) );
			} else {
				iKeyCode = m_draw.GetKeyb()->GetKeytopCode( HIWORD(lParam), 640 - LOWORD(lParam) );
			}

			//	^b`Ƃ̓L[̏ꍇ̂ݗL
			if ( iDownKeyCode == iKeyCode  ) {
				m_draw.GetKeyb()->KeyUp( iKeyCode );
				if ( m_draw.GetKeyb()->GetPressedStatus(iKeyCode) == false ) {
					m_keyif.KeyUp( iKeyCode );
				}
				m_draw.SetDrawKeybStatus( GAPIDrawVga::kbdraw );

				switch ( iKeyCode ) {
				case 0:
					{
						Wm5ConfigDialog config( GetM88Config(), GetDiskImageManager(), m_pKeyDef );

						IsExecFocus = false;

						Activate( false );
						m_draw.ActivateGAPI( false );
						::SHFullScreen( GetHWnd(), SHFS_SHOWTASKBAR | SHFS_SHOWSIPBUTTON );
						config.Show( GetHWnd() );
						::SHFullScreen( GetHWnd(), SHFS_HIDETASKBAR | SHFS_HIDESIPBUTTON );
						m_draw.RequestPaint();
						m_draw.ActivateGAPI( true );
						Activate( true );

						IsExecFocus = true;
					}
					break;

				case 0x63:
					IsExecFocus = false;
					Activate( false );
					if( ::MessageBox( hWnd, _T("Reset?"), _T("M88/wm5"), MB_YESNO | MB_ICONQUESTION ) == IDYES ) {
						ApplyConfig();
						GetCore()->Reset();
					}
					m_draw.RequestPaint();
					Activate( true );
					IsExecFocus = true;
					break;

				case 0x64:
					IsExecFocus = false;
					Activate( false );
					if( ::MessageBox( hWnd, _T("Exit?"), _T("M88/wm5"), MB_YESNO | MB_ICONQUESTION ) == IDYES ) {
						m_draw.ActivateGAPI( false );
						::SendMessage( hWnd, WM_CLOSE, 0, 0 );
					} else {
						m_draw.RequestPaint();
						Activate( true );
						IsExecFocus = true;
					}
					break;
				}

			} else {
				m_draw.GetKeyb()->KeyUp( iDownKeyCode );
				if ( m_draw.GetKeyb()->GetPressedStatus(iDownKeyCode) == false ) {
					m_keyif.KeyUp( iDownKeyCode );
				}
				m_draw.SetDrawKeybStatus( GAPIDrawVga::kbdraw );
			}
			iDownKeyCode = 0xff;
		}
		break;

	// \tgL[{[h肷܂ł̏I by NNK
	case WM_RBUTTONUP:
		IsExecFocus = false;
		Activate( false );
		if( ::MessageBox( hWnd, _T("Exit?"), _T("M88/wm5"), MB_YESNO | MB_ICONQUESTION ) == IDYES ) {
			m_draw.ActivateGAPI( false );
			::SendMessage( hWnd, WM_CLOSE, 0, 0 );
		} else {
			m_draw.RequestPaint();
			Activate( true );
			IsExecFocus = true;
		}
		break;

	case WM_CLOSE:
		Activate( false );
		m_draw.ActivateGAPI( false );
		::DestroyWindow( hWnd );
		break;

	case WM_DESTROY:
		::PostQuitMessage( 0 );
		::SHFullScreen( GetHWnd(), SHFS_SHOWTASKBAR | SHFS_SHOWSIPBUTTON );
		break;

	default:
		return DefWindowProc( hWnd, uMsg, wParam, lParam );
	}

	return 0;
}



