/*===========================================================================
		M88 for PocketPC
		Original Version (c)cisc
		Pocket PC Version Programmed by Y.Taniuchi ( TAN-Y )

		PocketPC ŊR[hpwb_t@C

		TAN-Y Ǝ݌v̕ɊւĂ͕K cisc ̐݌vvzɏ
		킯ł͂Ȃ̂ł炸....
===========================================================================*/

#ifndef _M88_POCKET
#define _M88_POCKET

#include "m88ce.h"
#include <gx.h>
#include <aygshell.h>
#include "CGAPISoftKeybVga.h"

//	LL[R[h̉
#define KEYCODE_MIN 0x01

//	LL[R[h̏
#define KEYCODE_MAX 0x62

#define M88WM5_KEYDEFFILENAME	"M88wm5_key.def" 



/*--------------------------------------------------------------------------
	L[`t@CNX
--------------------------------------------------------------------------*/

class Wm5KeyDefFile
{
private:
	int m_aiKeyCode[256];
	char *m_szFileName;
	GXKeyList *m_pGXkl;

public:
	Wm5KeyDefFile( const char *szFileName, GXKeyList *pGXkl );
	~Wm5KeyDefFile();

	void SetFileName( const char *szFileName );

	int GetKeyCode( int iIndex ){ return m_aiKeyCode[iIndex]; }
	void SetKeyCode( int iIndex, int iKey )
	{
		m_aiKeyCode[ iIndex ] = iKey;
	}

	GXKeyList *GetGXKeyList( void ){ return m_pGXkl; }

	bool Load();
	bool Save();

	void InitKey( void );
};


/*--------------------------------------------------------------------------
	PocketPC GAPIp Draw NXB
	Draw NX𒼐ڌpĂ܂i{ M88 Ƃ͕@Ⴂ܂jB
--------------------------------------------------------------------------*/

class GAPIDrawVga
	: public WCEDraw
{
public:
	enum DrawKeybStatus {
		kbnormal, kbdraw, kbredraw
	};

private:
	PC8801::Config   *m_pConfig;
	CGAPISoftKeybVga *m_pKeyb;
	DrawKeybStatus    m_dks;
	volatile bool     m_blActiveGAPI;

	GXDisplayProperties m_gxdp;

	long m_lDstXXH;				//	pEւ̃CfbNXZl

	//
	//	`֐
	//
	void DrawWindowH555( void *pDst, const uint8 *pSrc, RECT *pRect );
	void DrawWindowH565( void *pDst, const uint8 *pSrc, RECT *pRect );

	void DrawWindowH555_15kHz( void *pDst, const uint8 *pSrc, RECT *pRect );
	void DrawWindowH565_15kHz( void *pDst, const uint8 *pSrc, RECT *pRect );

	void DrawWindowH555_400( void *pDst, const uint8 *pSrc, RECT *pRect );
	void DrawWindowH565_400( void *pDst, const uint8 *pSrc, RECT *pRect );

public:
	GAPIDrawVga();
	~GAPIDrawVga();

	CGAPISoftKeybVga *GetKeyb( void ){ return m_pKeyb; }

	void SetDrawKeybStatus( DrawKeybStatus s ){ m_dks = s; }

	bool ActivateGAPI( bool blActive );


	void RequestPaint();	//	ăI[o[Ch

	void   DrawToScreen( uint8 *pImageSrc, RECT *pRect );
	uint8 *AllocVirtualDrawArea( uint width, uint height, uint bpp );
	bool   Init00( void );
	void   CleanupSub( uint8 *pImageSrc );
	void   SetConfig( PC8801::Config *pConfig );

};


/*--------------------------------------------------------------------------
	PocketPC p L[{[hfoCXNX
--------------------------------------------------------------------------*/

namespace PC8801
{

class Wm5KeyIF : public WCEKeyIF
{
public:

	Wm5KeyIF();
	~Wm5KeyIF();

	void KeyUp( int iKeyCode );
	void KeyDown( int iKeyCode );
};


}


/*--------------------------------------------------------------------------
	PocketPC p Core NX
--------------------------------------------------------------------------*/

class Wm5UI;

class Wm5Core : public PC88, public tl4::IRunnable
{
private:
	CriticalSection  m_cscpu;
	Wm5UI           *m_pUI;
	HWND             m_hWnd;
	tl4::CThread    *m_pThread;
	volatile bool    m_blThreadLoop;
	volatile bool    m_blActive;

	int m_iClock;
	int m_iExeccount;
	int m_iSpeed;
	int m_iEffclock;
	int m_iTime;


	uint32 GetMachineTime()
	{
		return ::timeGetTime();
		//return ::GetTickCount();
	}

	void ExecuteAsynchronus();
	void Execute( long lClock, long lLength, long lEffclock );

	bool ConnectDevices(PC8801::Wm5KeyIF* keyb);


public:
	Wm5Core();
	virtual ~Wm5Core();

	bool Init( Wm5UI *pUI, HWND hWnd, Draw *pDraw, DiskManager *pDiskmgr,
				PC8801::Wm5KeyIF *pKeyb ); 
	bool Cleanup();

	void Reset();
	void ApplyConfig(PC8801::Config *pConfig);

	DWORD Run();
	void Activate( bool blActive );

};



/*--------------------------------------------------------------------------
	ݒp_CAONX
--------------------------------------------------------------------------*/

#define CONFIGDIALOG_PAGEMAX 11

//
//	ey[WNX
//
class CPropControl : public CConfigPropSheetImpl< CPropControl >
{
public:

	CPropControl( PC8801::Config *pConfig ) : CConfigPropSheetImpl< CPropControl >( pConfig )
	{
	}

	enum { IDD = MAKEINTRESOURCE(IDD_CONFIG_WM5_MODE) };

	void SetActive(HWND hdlg);
	bool Command(HWND hdlg, HWND hwctl, UINT nc, UINT id);
};


class CPropDraw : public CConfigPropSheetImpl< CPropDraw >
{
private:

public:

	CPropDraw( PC8801::Config *pConfig ) : CConfigPropSheetImpl< CPropDraw >( pConfig )
	{
	}

	enum { IDD = MAKEINTRESOURCE(IDD_CONFIG_WM5_DRAW) };

	void SetActive(HWND hdlg);
	bool Command(HWND hdlg, HWND hwctl, UINT nc, UINT id);
};

class CPropDisk : public CConfigPropSheetImpl< CPropDisk >
{
private:
	CDiskImageManager *m_pDiskImageManager;
	void SetDiskImageList( HWND hWnd, uint uiDrive );

public:

	CPropDisk( PC8801::Config *pConfig, CDiskImageManager *pDiskImageManager ) : CConfigPropSheetImpl< CPropDisk >( pConfig )
	{
		m_pDiskImageManager = pDiskImageManager;
	}

	enum { IDD = MAKEINTRESOURCE(IDD_CONFIG_WM5_DISK) };

	void SetActive(HWND hdlg);
	bool Command(HWND hdlg, HWND hwctl, UINT nc, UINT id);
};

class CPropKeyMap;

class CPropKeyMapKeySel : public CWindowImpl< CPropKeyMapKeySel >
{
private:
	BEGIN_MSG_MAP( CPropKeyMapKeySel )
		MESSAGE_HANDLER( WM_KEYUP, OnKeyUp )
		MESSAGE_HANDLER( WM_KEYDOWN, OnKeyDown )
	END_MSG_MAP()

	LRESULT OnKeyUp( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &blHandled);
	LRESULT OnKeyDown( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &blHandled);

	CPropKeyMap *m_pPropKeyMap;


public:
	CPropKeyMapKeySel( CPropKeyMap *pPropKeyMap ) : CWindowImpl< CPropKeyMapKeySel >()
	{
		m_pPropKeyMap = pPropKeyMap;
	}
};


class CPropKeyMap : public CConfigPropSheetImpl< CPropKeyMap >
{
friend CPropKeyMapKeySel;

private:
	Wm5KeyDefFile *m_pKeyDef;

	void UpdateConfigKeyList( void );

	CPropKeyMapKeySel *m_pKeySelSubClass;

public:

	CPropKeyMap( PC8801::Config *pConfig, Wm5KeyDefFile *pKeyDef ) : CConfigPropSheetImpl< CPropKeyMap >( pConfig )
	{
		m_pKeySelSubClass = new CPropKeyMapKeySel( this );
		m_pKeyDef = pKeyDef;
	}

	~CPropKeyMap()
	{
		RELEASE_OBJ( m_pKeySelSubClass );
	}

	enum { IDD = MAKEINTRESOURCE(IDD_CONFIG_WM5_KMAP) };

	void SetActive(HWND hdlg);
	void InitDialog(HWND hdlg);
	bool Command(HWND hdlg, HWND hwctl, UINT nc, UINT id);


};


class CPropAbout : public CConfigPropSheetImpl< CPropAbout >
{
public:

	CPropAbout( PC8801::Config *pConfig ) : CConfigPropSheetImpl< CPropAbout >( pConfig )
	{
	}

	enum { IDD = MAKEINTRESOURCE(IDD_ABOUT) };

	void InitDialog(HWND hdlg);
};


//
//	_CAO{
//
class Wm5ConfigDialog : public CConfigDialog
{
private:
	CPropControl *m_pPropControl;
	CPropDisk    *m_pPropDisk;
	CPropDraw    *m_pPropDraw;
	CPropCPU     *m_pPropCPU;
	CPropSound1  *m_pPropSound1;
	CPropSound2  *m_pPropSound2;
	CPropSound3  *m_pPropSound3;
	CPropDipSW1  *m_pPropDipSW1;
	CPropDipSW2  *m_pPropDipSW2;
	CPropKeyMap  *m_pPropKeyMap;
	CPropAbout   *m_pPropAbout;

	Wm5KeyDefFile *m_pKeyDef;

protected:
	void  InitPSPHeader( PROPSHEETHEADER *pPSPHeader );
	bool  InitPSP( HPROPSHEETPAGE *phPSP );
	DWORD GetDialogFlag();

public:
	Wm5ConfigDialog( PC8801::Config *pConfig, CDiskImageManager *pDiskImageManager, Wm5KeyDefFile *pKeyDefFile );
	~Wm5ConfigDialog();

};




/*--------------------------------------------------------------------------
	UI NXBWinUI ɑB
	InstanceThunk gp̂߁ACX^X͈ȂB
--------------------------------------------------------------------------*/


class Wm5UI : public WCEUI
{
private:

//	CWm5Config       *m_pWm5Config;
	GAPIDrawVga       m_draw;
	PC8801::Wm5KeyIF  m_keyif;
	GXKeyList         m_gxkl;
	bool              m_bLandscape;
	Wm5KeyDefFile    *m_pKeyDef;

public:
	Wm5UI( HINSTANCE hInst );
	~Wm5UI();

	virtual bool InitM88Sub( void );
	virtual void CleanupM88Sub( void );
	virtual HWND CreateMainWindow( void );

	virtual LRESULT WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

	bool IsLandscape( void ) { return m_bLandscape; }
};


#endif
